# tinkoff_invest_api
Dart client for Tinkoff Investment open API 

See https://github.com/TinkoffCreditSystems/invest-openapi

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Build package: org.openapitools.codegen.languages.DartDioNextClientCodegen

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: tinkoff_invest_api
version: 0.1.0
description: OpenAPI API client
dependencies:
  tinkoff_invest_api:
    git: https://github.com/ILAgent/tinkoff_invest_api
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  tinkoff_invest_api:
    path: /path/to/tinkoff_invest_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:tinkoff_invest_api/tinkoff_invest_api.dart';


final api = MarketApi();

try {
    final response = await api.marketBondsGet();
    print(response);
} catch on DioError (e) {
    print("Exception when calling MarketApi->marketBondsGet: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api-invest.tinkoff.ru/openapi*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*MarketApi* | [**marketBondsGet**](doc/MarketApi.md#marketbondsget) | **get** /market/bonds | Получение списка облигаций
*MarketApi* | [**marketCandlesGet**](doc/MarketApi.md#marketcandlesget) | **get** /market/candles | Получение исторических свечей по FIGI
*MarketApi* | [**marketCurrenciesGet**](doc/MarketApi.md#marketcurrenciesget) | **get** /market/currencies | Получение списка валютных пар
*MarketApi* | [**marketEtfsGet**](doc/MarketApi.md#marketetfsget) | **get** /market/etfs | Получение списка ETF
*MarketApi* | [**marketOrderbookGet**](doc/MarketApi.md#marketorderbookget) | **get** /market/orderbook | Получение стакана по FIGI
*MarketApi* | [**marketSearchByFigiGet**](doc/MarketApi.md#marketsearchbyfigiget) | **get** /market/search/by-figi | Получение инструмента по FIGI
*MarketApi* | [**marketSearchByTickerGet**](doc/MarketApi.md#marketsearchbytickerget) | **get** /market/search/by-ticker | Получение инструмента по тикеру
*MarketApi* | [**marketStocksGet**](doc/MarketApi.md#marketstocksget) | **get** /market/stocks | Получение списка акций
*OperationsApi* | [**operationsGet**](doc/OperationsApi.md#operationsget) | **get** /operations | Получение списка операций
*OrdersApi* | [**ordersCancelPost**](doc/OrdersApi.md#orderscancelpost) | **post** /orders/cancel | Отмена заявки
*OrdersApi* | [**ordersGet**](doc/OrdersApi.md#ordersget) | **get** /orders | Получение списка активных заявок
*OrdersApi* | [**ordersLimitOrderPost**](doc/OrdersApi.md#orderslimitorderpost) | **post** /orders/limit-order | Создание лимитной заявки
*OrdersApi* | [**ordersMarketOrderPost**](doc/OrdersApi.md#ordersmarketorderpost) | **post** /orders/market-order | Создание рыночной заявки
*PortfolioApi* | [**portfolioCurrenciesGet**](doc/PortfolioApi.md#portfoliocurrenciesget) | **get** /portfolio/currencies | Получение валютных активов клиента
*PortfolioApi* | [**portfolioGet**](doc/PortfolioApi.md#portfolioget) | **get** /portfolio | Получение портфеля клиента
*SandboxApi* | [**sandboxClearPost**](doc/SandboxApi.md#sandboxclearpost) | **post** /sandbox/clear | Удаление всех позиций
*SandboxApi* | [**sandboxCurrenciesBalancePost**](doc/SandboxApi.md#sandboxcurrenciesbalancepost) | **post** /sandbox/currencies/balance | Выставление баланса по валютным позициям
*SandboxApi* | [**sandboxPositionsBalancePost**](doc/SandboxApi.md#sandboxpositionsbalancepost) | **post** /sandbox/positions/balance | Выставление баланса по инструментным позициям
*SandboxApi* | [**sandboxRegisterPost**](doc/SandboxApi.md#sandboxregisterpost) | **post** /sandbox/register | Регистрация клиента в sandbox
*SandboxApi* | [**sandboxRemovePost**](doc/SandboxApi.md#sandboxremovepost) | **post** /sandbox/remove | Удаление счета
*UserApi* | [**userAccountsGet**](doc/UserApi.md#useraccountsget) | **get** /user/accounts | Получение брокерских счетов клиента


## Documentation For Models

 - [BrokerAccountType](doc/BrokerAccountType.md)
 - [Candle](doc/Candle.md)
 - [CandleResolution](doc/CandleResolution.md)
 - [Candles](doc/Candles.md)
 - [CandlesResponse](doc/CandlesResponse.md)
 - [Currencies](doc/Currencies.md)
 - [Currency](doc/Currency.md)
 - [CurrencyPosition](doc/CurrencyPosition.md)
 - [Empty](doc/Empty.md)
 - [Error](doc/Error.md)
 - [ErrorPayload](doc/ErrorPayload.md)
 - [InstrumentType](doc/InstrumentType.md)
 - [LimitOrderRequest](doc/LimitOrderRequest.md)
 - [LimitOrderResponse](doc/LimitOrderResponse.md)
 - [MarketInstrument](doc/MarketInstrument.md)
 - [MarketInstrumentList](doc/MarketInstrumentList.md)
 - [MarketInstrumentListResponse](doc/MarketInstrumentListResponse.md)
 - [MarketInstrumentResponse](doc/MarketInstrumentResponse.md)
 - [MarketOrderRequest](doc/MarketOrderRequest.md)
 - [MarketOrderResponse](doc/MarketOrderResponse.md)
 - [MoneyAmount](doc/MoneyAmount.md)
 - [Operation](doc/Operation.md)
 - [OperationStatus](doc/OperationStatus.md)
 - [OperationTrade](doc/OperationTrade.md)
 - [OperationType](doc/OperationType.md)
 - [OperationTypeWithCommission](doc/OperationTypeWithCommission.md)
 - [Operations](doc/Operations.md)
 - [OperationsResponse](doc/OperationsResponse.md)
 - [Order](doc/Order.md)
 - [OrderResponse](doc/OrderResponse.md)
 - [OrderStatus](doc/OrderStatus.md)
 - [OrderType](doc/OrderType.md)
 - [Orderbook](doc/Orderbook.md)
 - [OrderbookResponse](doc/OrderbookResponse.md)
 - [OrdersResponse](doc/OrdersResponse.md)
 - [PlacedLimitOrder](doc/PlacedLimitOrder.md)
 - [PlacedMarketOrder](doc/PlacedMarketOrder.md)
 - [Portfolio](doc/Portfolio.md)
 - [PortfolioCurrenciesResponse](doc/PortfolioCurrenciesResponse.md)
 - [PortfolioPosition](doc/PortfolioPosition.md)
 - [PortfolioResponse](doc/PortfolioResponse.md)
 - [SandboxAccount](doc/SandboxAccount.md)
 - [SandboxCurrency](doc/SandboxCurrency.md)
 - [SandboxRegisterRequest](doc/SandboxRegisterRequest.md)
 - [SandboxRegisterResponse](doc/SandboxRegisterResponse.md)
 - [SandboxSetCurrencyBalanceRequest](doc/SandboxSetCurrencyBalanceRequest.md)
 - [SandboxSetPositionBalanceRequest](doc/SandboxSetPositionBalanceRequest.md)
 - [SearchMarketInstrument](doc/SearchMarketInstrument.md)
 - [SearchMarketInstrumentResponse](doc/SearchMarketInstrumentResponse.md)
 - [TradeStatus](doc/TradeStatus.md)
 - [UserAccount](doc/UserAccount.md)
 - [UserAccounts](doc/UserAccounts.md)
 - [UserAccountsResponse](doc/UserAccountsResponse.md)


## Documentation For Authorization


## sso_auth

- **Type**: HTTP basic authentication


## Author

n.v.melnikov@tinkoff.ru


